/* eslint-disable */
/* tslint:disable */
/*
 * ---------------------------------------------------------------
 * ## THIS FILE WAS GENERATED VIA SWAGGER-TYPESCRIPT-API        ##
 * ##                                                           ##
 * ## AUTHOR: acacode                                           ##
 * ## SOURCE: https://github.com/acacode/swagger-typescript-api ##
 * ---------------------------------------------------------------
 */

import { AxiosResponse } from 'axios'
import {    
    ResultOutputInt64,
    ResultOutputPageOutputNoticeGetPageOutput,    
    ResultOutputNoticeGetOutput,
    NoticeAddInput,    
    NoticeUpdateInput,    
    PageInputNoticeGetPageDto,
} from './data-contracts'
import { ContentType, HttpClient, RequestParams } from './http-client'

export class NoticeApi<SecurityDataType = unknown> extends HttpClient<SecurityDataType> {
    /**
     * No description
     *
     * @tags notice
     * @name Get
     * @summary 查询公告
     * @request GET:/api/admin/notice/get
     * @secure
     */
    get = (
        query?: {
            /** @format int64 */
            id?: number
        },
        params: RequestParams = {}
    ) =>
        this.request<ResultOutputNoticeGetOutput, any>({
            path: `/api/admin/notice/get`,
            method: 'GET',
            query: query,
            secure: true,
            format: 'json',
            ...params,
        })
    /**
     * No description
     *
     * @tags notice
     * @name GetPage
     * @summary 查询分页
     * @request POST:/api/admin/notice/get-page
     * @secure
     */
    getPage = (data: PageInputNoticeGetPageDto, params: RequestParams = {}) =>
        this.request<ResultOutputPageOutputNoticeGetPageOutput, any>({
            path: `/api/admin/notice/get-page`,
            method: 'POST',
            body: data,
            secure: true,
            type: ContentType.Json,
            format: 'json',
            ...params,
        })
        
    /**
     * No description
     *
     * @tags notice
     * @name Add
     * @summary 新增公告
     * @request POST:/api/admin/notice/add
     * @secure
     */
    add = (data: NoticeAddInput, params: RequestParams = {}) =>
        this.request<ResultOutputInt64, any>({
            path: `/api/admin/notice/add`,
            method: 'POST',
            body: data,
            secure: true,
            type: ContentType.Json,
            format: 'json',
            ...params,
        })
    /**
     * No description
     *
     * @tags notice
     * @name Update
     * @summary 修改公告
     * @request PUT:/api/admin/notice/update
     * @secure
     */
    update = (data: NoticeUpdateInput, params: RequestParams = {}) =>
        this.request<AxiosResponse, any>({
            path: `/api/admin/notice/update`,
            method: 'PUT',
            body: data,
            secure: true,
            type: ContentType.Json,
            ...params,
        })          
    /**
     * No description
     *
     * @tags notice
     * @name SoftDelete
     * @summary 删除公告
     * @request DELETE:/api/admin/notice/soft-delete
     * @secure
     */
    softDelete = (
        query?: {
            /** @format int64 */
            id?: number
        },
        params: RequestParams = {}
    ) =>
        this.request<AxiosResponse, any>({
            path: `/api/admin/notice/soft-delete`,
            method: 'DELETE',
            query: query,
            secure: true,
            ...params,
        })  
    /**
     * No description
     *
     * @tags notice
     * @name Get
     * @summary 查询重要公告
     * @request GET:/api/admin/notice/get-weight
     * @secure
     */
    getWeight = (
        query?: {
            
        },
        params: RequestParams = {}
    ) =>
        this.request<ResultOutputNoticeGetOutput, any>({
            path: `/api/admin/notice/get-weight`,
            method: 'GET',
            query: query,
            secure: true,
            format: 'json',
            ...params,
        })
}

